# settings_gui.cpp File Reference

GUI for settings. More...

`#include "stdafx.h"`
`#include "openttd.h"`
`#include "currency.h"`
`#include "gui.h"`
`#include "window_gui.h"`
`#include "textbuf_gui.h"`
`#include "command_func.h"`
`#include "engine_func.h"`
`#include "screenshot.h"`
`#include "network/network.h"`
`#include "town.h"`
`#include "variables.h"`
`#include "settings_internal.h"`
`#include "newgrf_townname.h"`
`#include "strings_func.h"`
`#include "window_func.h"`
`#include "string_func.h"`
`#include "gfx_func.h"`
`#include "waypoint.h"`
`#include "widgets/dropdown_type.h"`
`#include "widgets/dropdown_func.h"`
`#include "station_func.h"`
`#include "highscore.h"`
`#include "gfxinit.h"`
`#include <map>`
`#include "table/sprites.h"`
`#include "table/strings.h"`

Go to the source code of this file.

## Data Structures
struct | GameOptionsWindow
struct | GameDifficultyWindow
struct | SettingEntrySubtree
| Data fields for a sub-page (SEF_SUBTREE_KIND kind). More...
struct | SettingEntrySetting
| Data fields for a single setting (SEF_SETTING_KIND kind). More...
struct | SettingEntry
| Data structure describing a single setting in a tab. More...
struct | SettingsPage
| Data structure describing one page of settings in the settings window. More...
struct | GameSettingsWindow
struct | CustomCurrencyWindow
## Enumerations
enum | GameOptionsWidgets { GAMEOPT_CURRENCY_BTN = 4, GAMEOPT_DISTANCE_BTN = 6, GAMEOPT_ROADSIDE_BTN = 8, GAMEOPT_TOWNNAME_BTN = 10, GAMEOPT_AUTOSAVE_BTN = 12, GAMEOPT_LANG_BTN = 14, GAMEOPT_RESOLUTION_BTN = 16, GAMEOPT_FULLSCREEN, GAMEOPT_SCREENSHOT_BTN = 19, GAMEOPT_BASE_GRF_BTN = 21 }
enum | SettingEntryFlags { SEF_LEFT_DEPRESSED = 0x01, SEF_RIGHT_DEPRESSED = 0x02, SEF_BUTTONS_MASK = (SEF_LEFT_DEPRESSED | SEF_RIGHT_DEPRESSED), SEF_LAST_FIELD = 0x04, SEF_SETTING_KIND = 0x10, SEF_SUBTREE_KIND = 0x20, SEF_KIND_MASK = (SEF_SETTING_KIND | SEF_SUBTREE_KIND) }
| Flags for SettingEntry. More...
enum | GameSettingsWidgets { SETTINGSEL_OPTIONSPANEL = 2, SETTINGSEL_SCROLLBAR, SETTINGSEL_RESIZE }
| Widget numbers of settings window. More...
enum | CustomCurrenciesWidgets { CUSTCURR_EXCHANGERATE = 0, CUSTCURR_SEPARATOR, CUSTCURR_PREFIX, CUSTCURR_SUFFIX, CUSTCURR_TO_EURO }
| These are not, strickly speaking, widget enums, since they have been changed as line coordinates. More...
## Functions
static StringID * | BuildDynamicDropdown (StringID base, int num)
void | InitGRFTownGeneratorNames ()
static StringID | TownName (int town_name)
static int | GetCurRes ()
static void | ShowTownnameDropdown (Window *w, int sel)
| Update/redraw the townnames dropdown.
static void | ShowCustCurrency ()
static void | ShowGraphicsSetMenu (Window *w)
void | ShowGameOptions ()
void | StartupEconomy ()
void | SetDifficultyLevel (int mode, DifficultySettings *gm_opt)
void | ShowGameDifficulty ()
void | ShowGameSettings ()
void | DrawArrowButtons (int x, int y, Colours button_colour, byte state, bool clickable_left, bool clickable_right)
| Draw [<][>] boxes.
## Variables
static const StringID | _units_dropdown []
static const StringID | _driveside_dropdown []
static const StringID | _autosave_dropdown []
int | _nb_orig_names = SPECSTR_TOWNNAME_LAST - SPECSTR_TOWNNAME_START + 1
static StringID * | _grf_names = NULL
static int | _nb_grf_names = 0
static const Widget | _game_options_widgets []
static const WindowDesc | _game_options_desc
static const Widget | _game_difficulty_widgets []
static const WindowDesc | _game_difficulty_desc
static const int | SETTING_HEIGHT = 11
| Height of a single setting in the tree view in pixels.
static const int | LEVEL_WIDTH = 15
| Indenting width of a sub-page in pixels.
static SettingEntry | _settings_ui_display []
static SettingsPage | _settings_ui_display_page = {_settings_ui_display, lengthof(_settings_ui_display)}
| Display options sub-page.
static SettingEntry | _settings_ui_interaction []
static SettingsPage | _settings_ui_interaction_page = {_settings_ui_interaction, lengthof(_settings_ui_interaction)}
| Interaction sub-page.
static SettingEntry | _settings_ui []
static SettingsPage | _settings_ui_page = {_settings_ui, lengthof(_settings_ui)}
| Interface subpage.
static SettingEntry | _settings_construction_signals []
static SettingsPage | _settings_construction_signals_page = {_settings_construction_signals, lengthof(_settings_construction_signals)}
| Signals subpage.
static SettingEntry | _settings_construction []
static SettingsPage | _settings_construction_page = {_settings_construction, lengthof(_settings_construction)}
| Construction sub-page.
static SettingEntry | _settings_stations_cargo []
static SettingsPage | _settings_stations_cargo_page = {_settings_stations_cargo, lengthof(_settings_stations_cargo)}
| Cargo handling sub-page.
static SettingEntry | _settings_stations []
static SettingsPage | _settings_stations_page = {_settings_stations, lengthof(_settings_stations)}
| Stations sub-page.
static SettingEntry | _settings_economy_towns []
static SettingsPage | _settings_economy_towns_page = {_settings_economy_towns, lengthof(_settings_economy_towns)}
| Towns sub-page.
static SettingEntry | _settings_economy_industries []
static SettingsPage | _settings_economy_industries_page = {_settings_economy_industries, lengthof(_settings_economy_industries)}
| Industries sub-page.
static SettingEntry | _settings_economy []
static SettingsPage | _settings_economy_page = {_settings_economy, lengthof(_settings_economy)}
| Economy sub-page.
static SettingEntry | _settings_ai_npc []
static SettingsPage | _settings_ai_npc_page = {_settings_ai_npc, lengthof(_settings_ai_npc)}
| Computer players sub-page.
static SettingEntry | _settings_ai []
static SettingsPage | _settings_ai_page = {_settings_ai, lengthof(_settings_ai)}
| AI sub-page.
static SettingEntry | _settings_vehicles_routing []
static SettingsPage | _settings_vehicles_routing_page = {_settings_vehicles_routing, lengthof(_settings_vehicles_routing)}
| Autorenew sub-page.
static SettingEntry | _settings_vehicles_autorenew []
static SettingsPage | _settings_vehicles_autorenew_page = {_settings_vehicles_autorenew, lengthof(_settings_vehicles_autorenew)}
| Autorenew sub-page.
static SettingEntry | _settings_vehicles_servicing []
static SettingsPage | _settings_vehicles_servicing_page = {_settings_vehicles_servicing, lengthof(_settings_vehicles_servicing)}
| Servicing sub-page.
static SettingEntry | _settings_vehicles_trains []
static SettingsPage | _settings_vehicles_trains_page = {_settings_vehicles_trains, lengthof(_settings_vehicles_trains)}
| Trains sub-page.
static SettingEntry | _settings_vehicles []
static SettingsPage | _settings_vehicles_page = {_settings_vehicles, lengthof(_settings_vehicles)}
| Vehicles sub-page.
static SettingEntry | _settings_main []
static SettingsPage | _settings_main_page = {_settings_main, lengthof(_settings_main)}
| Main page, holding all advanced settings.
static const Widget | _settings_selection_widgets []
static const WindowDesc | _settings_selection_desc
static const Widget | _cust_currency_widgets []
static const WindowDesc | _cust_currency_desc

## Detailed Description

GUI for settings.

Definition in file settings_gui.cpp.

## Enumeration Type Documentation

enum CustomCurrenciesWidgets

These are not, strickly speaking, widget enums, since they have been changed as line coordinates.

So, rather, they are more like order of appearance

Definition at line 1476 of file settings_gui.cpp.

enum GameSettingsWidgets

Widget numbers of settings window.

Enumerator:

  SETTINGSEL_OPTIONSPANEL | Panel widget containing the option lists.
  SETTINGSEL_SCROLLBAR | Scrollbar.
  SETTINGSEL_RESIZE | Resize button.

Definition at line 1229 of file settings_gui.cpp.

enum SettingEntryFlags

Flags for SettingEntry.

Note:
  The SEF_BUTTONS_MASK matches expectations of the formal parameter 'state' of DrawArrowButtons

Enumerator:

  SEF_LEFT_DEPRESSED | Of a numeric setting entry, the left button is depressed.
  SEF_RIGHT_DEPRESSED | Of a numeric setting entry, the right button is depressed.
  SEF_BUTTONS_MASK | Bit-mask for button flags.
  SEF_LAST_FIELD | This entry is the last one in a (sub-)page.
  SEF_SETTING_KIND | Entry kind: Entry is a setting.
  SEF_SUBTREE_KIND | Entry kind: Entry is a sub-tree.
  SEF_KIND_MASK | Bit-mask for fetching entry kind.

Definition at line 603 of file settings_gui.cpp.

## Function Documentation

void DrawArrowButtons | ( | int | x,
|  | int | y,
|  | Colours | button_colour,
|  | byte | state,
|  | bool | clickable_left,
|  | bool | clickable_right |
| ) |  |  |

Draw [<][>] boxes.

Parameters:

  | x | the x position to draw
  | y | the y position to draw
  | button_colour | the colour of the button
  | state | 0 = none clicked, 1 = first clicked, 2 = second clicked
  | clickable_left | is the left button clickable?
  | clickable_right | is the right button clickable?

Definition at line 1455 of file settings_gui.cpp.

References _colour_gradient, DrawFrameRect(), DrawStringCentered(), FILLRECT_CHECKER, FR_LOWERED, and GfxFillRect().

Referenced by SettingEntry::DrawSetting(), AIConfigWindow::OnPaint(), and AISettingsWindow::OnPaint().

static void ShowTownnameDropdown | ( | Window * | w,
|  | int | sel |
| ) |  |  | `[static]`

Update/redraw the townnames dropdown.

Parameters:

  | w | the window the dropdown belongs to
  | sel | the currently selected townname generator

Definition at line 116 of file settings_gui.cpp.

References ShowDropDownList().

## Variable Documentation

const StringID _autosave_dropdown[]`[static]`

Initial value:

     {
      STR_02F7_OFF,
      STR_AUTOSAVE_1_MONTH,
      STR_02F8_EVERY_3_MONTHS,
      STR_02F9_EVERY_6_MONTHS,
      STR_02FA_EVERY_12_MONTHS,
      INVALID_STRING_ID,
    }

Definition at line 47 of file settings_gui.cpp.

const WindowDesc _cust_currency_desc`[static]`

Initial value:

     {
      WDP_CENTER, WDP_CENTER, 230, 120, 230, 120,
      WC_CUSTOM_CURRENCY, WC_NONE,
      WDF_STD_TOOLTIPS | WDF_STD_BTN | WDF_DEF_WIDGET | WDF_UNCLICK_BUTTONS,
      _cust_currency_widgets,
    }

Definition at line 1665 of file settings_gui.cpp.

const Widget _cust_currency_widgets[]`[static]`

Initial value:

     {
    {   WWT_CLOSEBOX,   RESIZE_NONE,  COLOUR_GREY,     0,    10,     0,    13, STR_00C5,            STR_018B_CLOSE_WINDOW},
    {    WWT_CAPTION,   RESIZE_NONE,  COLOUR_GREY,    11,   229,     0,    13, STR_CURRENCY_WINDOW, STR_018C_WINDOW_TITLE_DRAG_THIS},
    {      WWT_PANEL,   RESIZE_NONE,  COLOUR_GREY,     0,   229,    14,   119, 0x0,                 STR_NULL},
    {   WIDGETS_END},
    }

Definition at line 1658 of file settings_gui.cpp.

const StringID _driveside_dropdown[]`[static]`

Initial value:

     {
      STR_02E9_DRIVE_ON_LEFT,
      STR_02EA_DRIVE_ON_RIGHT,
      INVALID_STRING_ID
    }

Definition at line 41 of file settings_gui.cpp.

const WindowDesc _game_difficulty_desc`[static]`

Initial value:

     {
      WDP_CENTER, WDP_CENTER, 370, 279, 370, 279,
      WC_GAME_OPTIONS, WC_NONE,
      WDF_STD_TOOLTIPS | WDF_STD_BTN | WDF_DEF_WIDGET,
      _game_difficulty_widgets,
    }

Definition at line 389 of file settings_gui.cpp.

const Widget _game_difficulty_widgets[]`[static]`

Initial value:

     {
    {   WWT_CLOSEBOX,   RESIZE_NONE,  COLOUR_MAUVE,      0,    10,     0,    13, STR_00C5,                     STR_018B_CLOSE_WINDOW},
    {    WWT_CAPTION,   RESIZE_NONE,  COLOUR_MAUVE,     11,   369,     0,    13, STR_6800_DIFFICULTY_LEVEL,    STR_018C_WINDOW_TITLE_DRAG_THIS},
    {      WWT_PANEL,   RESIZE_NONE,  COLOUR_MAUVE,      0,   369,    14,    41, 0x0,                          STR_NULL},
    { WWT_PUSHTXTBTN,   RESIZE_NONE,  COLOUR_YELLOW,    10,    96,    16,    27, STR_6801_EASY,                STR_NULL},
    { WWT_PUSHTXTBTN,   RESIZE_NONE,  COLOUR_YELLOW,    97,   183,    16,    27, STR_6802_MEDIUM,              STR_NULL},
    { WWT_PUSHTXTBTN,   RESIZE_NONE,  COLOUR_YELLOW,   184,   270,    16,    27, STR_6803_HARD,                STR_NULL},
    { WWT_PUSHTXTBTN,   RESIZE_NONE,  COLOUR_YELLOW,   271,   357,    16,    27, STR_6804_CUSTOM,              STR_NULL},
    {    WWT_TEXTBTN,   RESIZE_NONE,  COLOUR_GREEN,     10,   357,    28,    39, STR_6838_SHOW_HI_SCORE_CHART, STR_NULL},
    {      WWT_PANEL,   RESIZE_NONE,  COLOUR_MAUVE,      0,   369,    42,   262, 0x0,                          STR_NULL},
    {      WWT_PANEL,   RESIZE_NONE,  COLOUR_MAUVE,      0,   369,   263,   278, 0x0,                          STR_NULL},
    { WWT_PUSHTXTBTN,   RESIZE_NONE,  COLOUR_YELLOW,   105,   185,   265,   276, STR_OPTIONS_SAVE_CHANGES,     STR_NULL},
    { WWT_PUSHTXTBTN,   RESIZE_NONE,  COLOUR_YELLOW,   186,   266,   265,   276, STR_012E_CANCEL,              STR_NULL},
    {   WIDGETS_END},
    }

Definition at line 372 of file settings_gui.cpp.

const WindowDesc _game_options_desc`[static]`

Initial value:

     {
      WDP_CENTER, WDP_CENTER, 370, 243, 370, 243,
      WC_GAME_OPTIONS, WC_NONE,
      WDF_STD_TOOLTIPS | WDF_STD_BTN | WDF_DEF_WIDGET | WDF_UNCLICK_BUTTONS,
      _game_options_widgets,
    }

Definition at line 355 of file settings_gui.cpp.

const Widget _game_options_widgets[]`[static]`

Initial value:

     {
    {   WWT_CLOSEBOX,   RESIZE_NONE,  COLOUR_GREY,     0,    10,     0,    13, STR_00C5,                          STR_018B_CLOSE_WINDOW},
    {    WWT_CAPTION,   RESIZE_NONE,  COLOUR_GREY,    11,   369,     0,    13, STR_00B1_GAME_OPTIONS,             STR_018C_WINDOW_TITLE_DRAG_THIS},
    {      WWT_PANEL,   RESIZE_NONE,  COLOUR_GREY,     0,   369,    14,   242, 0x0,                               STR_NULL},
    {      WWT_FRAME,   RESIZE_NONE,  COLOUR_GREY,    10,   179,    20,    55, STR_02E0_CURRENCY_UNITS,           STR_NULL},
    { WWT_DROPDOWNIN,   RESIZE_NONE,  COLOUR_GREY,    20,   169,    34,    45, STR_02E1,                          STR_02E2_CURRENCY_UNITS_SELECTION},
    {      WWT_FRAME,   RESIZE_NONE,  COLOUR_GREY,   190,   359,    20,    55, STR_MEASURING_UNITS,               STR_NULL},
    { WWT_DROPDOWNIN,   RESIZE_NONE,  COLOUR_GREY,   200,   349,    34,    45, STR_02E4,                          STR_MEASURING_UNITS_SELECTION},
    {      WWT_FRAME,   RESIZE_NONE,  COLOUR_GREY,    10,   179,    62,    97, STR_02E6_ROAD_VEHICLES,            STR_NULL},
    { WWT_DROPDOWNIN,   RESIZE_NONE,  COLOUR_GREY,    20,   169,    76,    87, STR_02E7,                          STR_02E8_SELECT_SIDE_OF_ROAD_FOR},
    {      WWT_FRAME,   RESIZE_NONE,  COLOUR_GREY,   190,   359,    62,    97, STR_02EB_TOWN_NAMES,               STR_NULL},
    { WWT_DROPDOWNIN,   RESIZE_NONE,  COLOUR_GREY,   200,   349,    76,    87, STR_02EC,                          STR_02ED_SELECT_STYLE_OF_TOWN_NAMES},
    {      WWT_FRAME,   RESIZE_NONE,  COLOUR_GREY,    10,   179,   104,   139, STR_02F4_AUTOSAVE,                 STR_NULL},
    { WWT_DROPDOWNIN,   RESIZE_NONE,  COLOUR_GREY,    20,   169,   118,   129, STR_02F5,                          STR_02F6_SELECT_INTERVAL_BETWEEN},

    {      WWT_FRAME,   RESIZE_NONE,  COLOUR_GREY,   190,   359,   104,   139, STR_OPTIONS_LANG,                  STR_NULL},
    { WWT_DROPDOWNIN,   RESIZE_NONE,  COLOUR_GREY,   200,   349,   118,   129, STR_OPTIONS_LANG_CBO,              STR_OPTIONS_LANG_TIP},

    {      WWT_FRAME,   RESIZE_NONE,  COLOUR_GREY,    10,   179,   146,   190, STR_OPTIONS_RES,                   STR_NULL},
    { WWT_DROPDOWNIN,   RESIZE_NONE,  COLOUR_GREY,    20,   169,   160,   171, STR_OPTIONS_RES_CBO,               STR_OPTIONS_RES_TIP},
    {    WWT_TEXTBTN,   RESIZE_NONE,  COLOUR_GREY,   149,   169,   176,   184, STR_EMPTY,                         STR_OPTIONS_FULLSCREEN_TIP},

    {      WWT_FRAME,   RESIZE_NONE,  COLOUR_GREY,   190,   359,   146,   190, STR_OPTIONS_SCREENSHOT_FORMAT,     STR_NULL},
    { WWT_DROPDOWNIN,   RESIZE_NONE,  COLOUR_GREY,   200,   349,   160,   171, STR_OPTIONS_SCREENSHOT_FORMAT_CBO, STR_OPTIONS_SCREENSHOT_FORMAT_TIP},

    {      WWT_FRAME,   RESIZE_NONE,  COLOUR_GREY,    10,   179,   197,   232, STR_OPTIONS_BASE_GRF,              STR_NULL},
    { WWT_DROPDOWNIN,   RESIZE_NONE,  COLOUR_GREY,    20,   169,   211,   222, STR_OPTIONS_BASE_GRF_CBO,          STR_OPTIONS_BASE_GRF_TIP},

    {   WIDGETS_END},
    }

Definition at line 324 of file settings_gui.cpp.

SettingEntry _settings_ai[]`[static]`

Initial value:

     {
      SettingEntry(&_settings_ai_npc_page, STR_CONFIG_SETTING_AI_NPC),
      SettingEntry("economy.give_money"),
      SettingEntry("economy.allow_shares"),
    }

Definition at line 1146 of file settings_gui.cpp.

SettingEntry _settings_ai_npc[]`[static]`

Initial value:

     {
      SettingEntry("ai.ai_in_multiplayer"),
      SettingEntry("ai.ai_disable_veh_train"),
      SettingEntry("ai.ai_disable_veh_roadveh"),
      SettingEntry("ai.ai_disable_veh_aircraft"),
      SettingEntry("ai.ai_disable_veh_ship"),
      SettingEntry("ai.ai_max_opcode_till_suspend"),
    }

Definition at line 1135 of file settings_gui.cpp.

SettingEntry _settings_construction[]`[static]`

Initial value:

     {
      SettingEntry(&_settings_construction_signals_page, STR_CONFIG_SETTING_CONSTRUCTION_SIGNALS),
      SettingEntry("construction.build_on_slopes"),
      SettingEntry("construction.autoslope"),
      SettingEntry("construction.extra_dynamite"),
      SettingEntry("construction.longbridges"),
      SettingEntry("station.always_small_airport"),
      SettingEntry("construction.freeform_edges"),
    }

Definition at line 1069 of file settings_gui.cpp.

SettingEntry _settings_construction_signals[]`[static]`

Initial value:

     {
      SettingEntry("construction.signal_side"),
      SettingEntry("gui.enable_signal_gui"),
      SettingEntry("gui.drag_signals_density"),
      SettingEntry("gui.semaphore_build_before"),
      SettingEntry("gui.default_signal_type"),
      SettingEntry("gui.cycle_signal_types"),
    }

Definition at line 1058 of file settings_gui.cpp.

SettingEntry _settings_economy[]`[static]`

Initial value:

     {
      SettingEntry(&_settings_economy_towns_page, STR_CONFIG_SETTING_ECONOMY_TOWNS),
      SettingEntry(&_settings_economy_industries_page, STR_CONFIG_SETTING_ECONOMY_INDUSTRIES),
      SettingEntry("economy.inflation"),
      SettingEntry("economy.smooth_economy"),
    }

Definition at line 1126 of file settings_gui.cpp.

SettingEntry _settings_economy_industries[]`[static]`

Initial value:

     {
      SettingEntry("construction.raw_industry_construction"),
      SettingEntry("economy.multiple_industry_per_town"),
      SettingEntry("economy.same_industry_close"),
      SettingEntry("game_creation.oil_refinery_limit"),
    }

Definition at line 1117 of file settings_gui.cpp.

SettingEntry _settings_economy_towns[]`[static]`

Initial value:

     {
      SettingEntry("economy.bribe"),
      SettingEntry("economy.exclusive_rights"),
      SettingEntry("economy.town_layout"),
      SettingEntry("economy.allow_town_roads"),
      SettingEntry("economy.mod_road_rebuild"),
      SettingEntry("economy.town_growth_rate"),
      SettingEntry("economy.larger_towns"),
      SettingEntry("economy.initial_city_size"),
    }

Definition at line 1104 of file settings_gui.cpp.

SettingEntry _settings_main[]`[static]`

Initial value:

     {
      SettingEntry(&_settings_ui_page,           STR_CONFIG_SETTING_GUI),
      SettingEntry(&_settings_construction_page, STR_CONFIG_SETTING_CONSTRUCTION),
      SettingEntry(&_settings_vehicles_page,     STR_CONFIG_SETTING_VEHICLES),
      SettingEntry(&_settings_stations_page,     STR_CONFIG_SETTING_STATIONS),
      SettingEntry(&_settings_economy_page,      STR_CONFIG_SETTING_ECONOMY),
      SettingEntry(&_settings_ai_page,           STR_CONFIG_SETTING_AI),
    }

Definition at line 1216 of file settings_gui.cpp.

const WindowDesc _settings_selection_desc`[static]`

Initial value:

     {
      WDP_CENTER, WDP_CENTER, 412, 188, 450, 397,
      WC_GAME_OPTIONS, WC_NONE,
      WDF_STD_TOOLTIPS | WDF_STD_BTN | WDF_DEF_WIDGET | WDF_RESIZABLE,
      _settings_selection_widgets,
    }

Definition at line 1432 of file settings_gui.cpp.

const Widget _settings_selection_widgets[]`[static]`

Initial value:

     {
    {   WWT_CLOSEBOX,   RESIZE_NONE,  COLOUR_MAUVE,     0,    10,     0,    13, STR_00C5,                        STR_018B_CLOSE_WINDOW},
    {    WWT_CAPTION,  RESIZE_RIGHT,  COLOUR_MAUVE,    11,   411,     0,    13, STR_CONFIG_SETTING_CAPTION,      STR_018C_WINDOW_TITLE_DRAG_THIS},
    {      WWT_PANEL,     RESIZE_RB,  COLOUR_MAUVE,     0,   399,    14,   187, 0x0,                             STR_NULL},
    {  WWT_SCROLLBAR,    RESIZE_LRB,  COLOUR_MAUVE,   400,   411,    14,   175, 0x0,                             STR_0190_SCROLL_BAR_SCROLLS_LIST},
    {  WWT_RESIZEBOX,   RESIZE_LRTB,  COLOUR_MAUVE,   400,   411,   176,   187, 0x0,                             STR_RESIZE_BUTTON},
    {   WIDGETS_END},
    }

Definition at line 1423 of file settings_gui.cpp.

SettingEntry _settings_stations[]`[static]`

Initial value:

     {
      SettingEntry(&_settings_stations_cargo_page, STR_CONFIG_SETTING_STATIONS_CARGOHANDLING),
      SettingEntry("station.join_stations"),
      SettingEntry("station.nonuniform_stations"),
      SettingEntry("station.adjacent_stations"),
      SettingEntry("station.distant_join_stations"),
      SettingEntry("station.station_spread"),
      SettingEntry("economy.station_noise_level"),
      SettingEntry("station.modified_catchment"),
      SettingEntry("construction.road_stop_on_town_road"),
      SettingEntry("construction.road_stop_on_competitor_road"),
    }

Definition at line 1089 of file settings_gui.cpp.

SettingEntry _settings_stations_cargo[]`[static]`

Initial value:

     {
      SettingEntry("order.improved_load"),
      SettingEntry("order.gradual_loading"),
      SettingEntry("order.selectgoods"),
    }

Definition at line 1081 of file settings_gui.cpp.

SettingEntry _settings_ui[]`[static]`

Initial value:

     {
      SettingEntry(&_settings_ui_display_page, STR_CONFIG_SETTING_DISPLAY_OPTIONS),
      SettingEntry(&_settings_ui_interaction_page, STR_CONFIG_SETTING_INTERACTION),
      SettingEntry("gui.show_finances"),
      SettingEntry("gui.errmsg_duration"),
      SettingEntry("gui.toolbar_pos"),
      SettingEntry("gui.pause_on_newgame"),
      SettingEntry("gui.advanced_vehicle_list"),
      SettingEntry("gui.timetable_in_ticks"),
      SettingEntry("gui.quick_goto"),
      SettingEntry("gui.default_rail_type"),
      SettingEntry("gui.always_build_infrastructure"),
      SettingEntry("gui.persistent_buildingtools"),
      SettingEntry("gui.coloured_news_year"),
    }

Definition at line 1040 of file settings_gui.cpp.

SettingEntry _settings_ui_display[]`[static]`

Initial value:

     {
      SettingEntry("gui.vehicle_speed"),
      SettingEntry("gui.status_long_date"),
      SettingEntry("gui.date_format_in_default_names"),
      SettingEntry("gui.population_in_label"),
      SettingEntry("gui.measure_tooltip"),
      SettingEntry("gui.loading_indicators"),
      SettingEntry("gui.liveries"),
      SettingEntry("gui.show_track_reservation"),
      SettingEntry("gui.expenses_layout"),
    }

Definition at line 1004 of file settings_gui.cpp.

SettingEntry _settings_ui_interaction[]`[static]`

Initial value:

     {
      SettingEntry("gui.window_snap_radius"),
      SettingEntry("gui.window_soft_limit"),
      SettingEntry("gui.link_terraform_toolbar"),
      SettingEntry("gui.prefer_teamchat"),
      SettingEntry("gui.autoscroll"),
      SettingEntry("gui.reverse_scroll"),
      SettingEntry("gui.smooth_scroll"),
      SettingEntry("gui.left_mouse_btn_scrolling"),

      SettingEntry("gui.scrollwheel_scrolling"),
      SettingEntry("gui.scrollwheel_multiplier"),

    }

Definition at line 1018 of file settings_gui.cpp.

SettingEntry _settings_vehicles[]`[static]`

Initial value:

     {
      SettingEntry(&_settings_vehicles_routing_page, STR_CONFIG_SETTING_VEHICLES_ROUTING),
      SettingEntry(&_settings_vehicles_autorenew_page, STR_CONFIG_SETTING_VEHICLES_AUTORENEW),
      SettingEntry(&_settings_vehicles_servicing_page, STR_CONFIG_SETTING_VEHICLES_SERVICING),
      SettingEntry(&_settings_vehicles_trains_page, STR_CONFIG_SETTING_VEHICLES_TRAINS),
      SettingEntry("order.gotodepot"),
      SettingEntry("gui.new_nonstop"),
      SettingEntry("gui.order_review_system"),
      SettingEntry("gui.vehicle_income_warn"),
      SettingEntry("vehicle.never_expire_vehicles"),
      SettingEntry("vehicle.max_trains"),
      SettingEntry("vehicle.max_roadveh"),
      SettingEntry("vehicle.max_aircraft"),
      SettingEntry("vehicle.max_ships"),
      SettingEntry("vehicle.plane_speed"),
      SettingEntry("order.timetabling"),
      SettingEntry("vehicle.dynamic_engines"),
    }

Definition at line 1195 of file settings_gui.cpp.

SettingEntry _settings_vehicles_autorenew[]`[static]`

Initial value:

     {
      SettingEntry("gui.autorenew"),
      SettingEntry("gui.autorenew_months"),
      SettingEntry("gui.autorenew_money"),
    }

Definition at line 1164 of file settings_gui.cpp.

SettingEntry _settings_vehicles_routing[]`[static]`

Initial value:

     {
      SettingEntry("pf.pathfinder_for_trains"),
      SettingEntry("pf.forbid_90_deg"),
      SettingEntry("pf.pathfinder_for_roadvehs"),
      SettingEntry("pf.roadveh_queue"),
      SettingEntry("pf.pathfinder_for_ships"),
    }

Definition at line 1154 of file settings_gui.cpp.

SettingEntry _settings_vehicles_servicing[]`[static]`

Initial value:

     {
      SettingEntry("vehicle.servint_ispercent"),
      SettingEntry("vehicle.servint_trains"),
      SettingEntry("vehicle.servint_roadveh"),
      SettingEntry("vehicle.servint_ships"),
      SettingEntry("vehicle.servint_aircraft"),
      SettingEntry("order.no_servicing_if_no_breakdowns"),
      SettingEntry("order.serviceathelipad"),
    }

Definition at line 1172 of file settings_gui.cpp.

SettingEntry _settings_vehicles_trains[]`[static]`

Initial value:

     {
      SettingEntry("vehicle.train_acceleration_model"),
      SettingEntry("vehicle.mammoth_trains"),
      SettingEntry("gui.lost_train_warn"),
      SettingEntry("vehicle.wagon_speed_limits"),
      SettingEntry("vehicle.disable_elrails"),
      SettingEntry("vehicle.freight_trains"),
    }

Definition at line 1184 of file settings_gui.cpp.

const StringID _units_dropdown[]`[static]`

Initial value:

     {
      STR_UNITS_IMPERIAL,
      STR_UNITS_METRIC,
      STR_UNITS_SI,
      INVALID_STRING_ID
    }

Definition at line 34 of file settings_gui.cpp.